#include <QDialog>
#include <QString>
#include <QTime>
#include "ui_mainform.h" 

class QTimer;
class QScriptEngine;

class Clock : public QDialog, public Ui::MainForm
{
    Q_OBJECT
public:
	Clock(QWidget *parent = 0);
	virtual ~Clock();
	Q_PROPERTY(QString timeFormat READ getTimeFormat WRITE setTimeFormat)
	Q_PROPERTY(QString dateFormat READ getDateFormat WRITE setDateFormat)
	Q_PROPERTY(QString currentTime READ getCurrentTime)
protected slots:
	void onTimeout();
	void execute(const QString & command);
private:
	QTimer * timer;
	QString m_timeFormat;
	QString m_dateFormat;
	void setTimeFormat(const QString & format) {m_timeFormat = format;};
	QString getTimeFormat() {return m_timeFormat;};
	void setDateFormat(const QString & format) {m_dateFormat = format;}; 
	QString getDateFormat() {return m_timeFormat;};
	QString getCurrentTime() {return QTime::currentTime().toString(m_timeFormat);};
	QScriptEngine * engine;
};
