#include "label.h"
#include <QtGui>

Label::Label(QWidget *parent) : QWidget(parent)
{	
	QFont font("Times", 22, -1, true);
	QString text = QObject::trUtf8("Этот фрагмент текста выведен на экран с помощью системы Scribe. Фигурное оформление выглядит непривычно, но может использоваться, например, в развлекательных программах. Как видите, Scribe  не только упрощает работу с форматированным текстом, но и расширяет возможности вывода обычного текста, хранящегося в строке.");		
	textLayout = new QTextLayout(text, font);
}

void Label::makeLayout()
{
	int indent = 20;
	qreal vertPos = 10;
	QTextLine line;	
	textLayout->beginLayout();
	line = textLayout->createLine();
	while (line.isValid())
	{
		line.setLineWidth(width() - 2 * indent);
		line.setPosition(QPointF(indent, vertPos));
		vertPos += line.height();
		indent += 20;
		line = textLayout->createLine();
	}
	textLayout->endLayout();
}

void Label::paintEvent(QPaintEvent *event)
{
	QPainter painter;
	QPen pen;
	makeLayout();			
	painter.begin(this);
	painter.eraseRect(QRect(0, 0, width(), height()));
	pen.setColor(QColor(0, 0, 127));
	painter.setPen(pen);
	textLayout->draw(&painter, QPoint(0,0));
	painter.end();
}
