#include <QtDebug>
#include <QtGui>
#include <QSqlDatabase>
#include <QSqlQueryModel>
#include <QSqlRelationalTableModel>
#include <QSqlError>
#include <QSqlRelation>
#include <QSqlRelationalDelegate>
#include <QStyleOptionViewItem>
#include <QModelIndex>
#include "customview.cpp"


int main(int argc, char *argv[])
{
	QApplication app(argc, argv);
	
	QSqlDatabase db = QSqlDatabase::addDatabase("QPSQL");
	db.setHostName("localhost");
    db.setDatabaseName("testdb");
    db.setUserName("andrei");
    db.setPassword("password");
    if (!db.open())
	{
		qDebug() << QObject::trUtf8("Не смогла я открыть базу данных") << db.lastError().text();	
		return -1;
	}
	
	
	QSqlRelationalTableModel * albumsRelation = new QSqlRelationalTableModel(0);
	albumsRelation->setTable("albums");
	albumsRelation->setRelation(1, QSqlRelation("artists", "artist_id", "name"));
	albumsRelation->select();
	albumsRelation->setEditStrategy(QSqlTableModel::OnManualSubmit);
	
	CustomView * view = new CustomView(0);
	view->setModel(albumsRelation);
	view->setColumnHidden(0, true);
	view->setWindowTitle(QObject::trUtf8("Альбомы"));
	QSqlRelationalDelegate * delegate = new QSqlRelationalDelegate(view);
	view->setItemDelegate(delegate);
	view->show();
	int result = app.exec();
	delete albumsRelation;
	return result;
}
