#include <QtDebug>
#include <QtGui>
#include <QSqlDatabase>
#include <QSqlQueryModel>
#include <QSqlRelationalTableModel>
#include <QSqlError>
#include <QSqlRelation>
#include <QSqlRelationalDelegate>


int main(int argc, char *argv[])
{
	QApplication app(argc, argv);
	
	QSqlDatabase db = QSqlDatabase::addDatabase("QPSQL");
	db.setHostName("localhost");
    db.setDatabaseName("testdb");
    db.setUserName("andrei");
    db.setPassword("password");
    if (!db.open())
	{
		qDebug() << QObject::trUtf8("Не смогла я открыть базу данных") << db.lastError().text();	
		return -1;
	}
	
	QSqlRelationalTableModel * compositionsRelation = new QSqlRelationalTableModel(0);
	compositionsRelation->setTable("compositions");
	compositionsRelation->setRelation(1, QSqlRelation("artists", "artist_id", "name"));
	compositionsRelation->setRelation(2, QSqlRelation("albums", "album_id", "title"));
	compositionsRelation->select();
	compositionsRelation->removeColumn(0);
	compositionsRelation->setHeaderData(0, Qt::Horizontal, QObject::trUtf8("Автор"));
	compositionsRelation->setHeaderData(1, Qt::Horizontal, QObject::trUtf8("Альбом"));
	compositionsRelation->setHeaderData(2, Qt::Horizontal, QObject::trUtf8("Год выхода"));
	compositionsRelation->setHeaderData(3, Qt::Horizontal, QObject::trUtf8("Композиция"));
	
	QTableView * view = new QTableView(0);
	view->setModel(compositionsRelation);
	view->setWindowTitle(QObject::trUtf8("Композиции"));

	view->show();

	int result = app.exec();
	delete compositionsRelation;
	return result;
}
